/* NFIDENT: a program for neuro-fuzzy function approximation

   Copyright (C) 1997-2000 

   Detlef Nauck (nauck@ieee.org, 
   http:\\fuzzy.cs.uni-magdeburg.de/~nauck)  
   hereby disclaims all copyright interests in the program 
   NFIDENT written by Detlef Nauck

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 1, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#include "global.h"
#include <signal.h>

double minimum (double x, double y)
{
  return ((x<y)?x:y);
};

double maximum (double x, double y)
{
  return ((x>y)?x:y);
};

double prod (double x, double y)
{
 return x * y;
};

void Init_Learn_Parameters (LParam *LP)
{
  LP->fstype = 0;
  LP->outstretch = 0;
  LP->tskinit = 0.1;
  LP->sigma_a = 0.1;
  LP->sigma_b = 0.1;
  LP->sigma_c = 0.1;
  LP->sigma_d = 0.1;
  LP->sigma_t = 0.1;
  LP->momentum = 0.9;
  LP->uselmse = 0;
  LP->tnorm = 0;
  LP->snorm = 0;
  LP->defuzz = 0;
  LP->maxrules = 0;
  LP->percent = 0.9;
  LP->minerror = 0.0;
  LP->chgepoch = 5;
  LP->minepoch = 0;
  LP->maxepoch = 100;
  LP->logepoch = 10;
  LP->batch = 1;
  LP->at05 = 0;
  LP->nopass = 1;
  LP->asym = 1;
  strcpy (LP->netfilename, "network.nfs");
  LP->loadnetfilename[0] = '\0';
  strcpy (LP->savenetfilename, "saved.nfs");
  strcpy (LP->logfilename, "nfident.log");
  strcpy (LP->gnufilename, "gnu.mfs");
  LP->trainingfilename[0] = '\0';
  LP->generalizationfilename[0] = '\0';
  LP->testfilename[0] = '\0';
  strcpy (LP->trainresultname,"trainres.dat");
  strcpy (LP->genresultname, "genres.dat");
  strcpy (LP->testresultname, "testres.dat");

}; /* Init Learn Parameters */


void INTHandler ()
{
  StopOnSignal = 1;
  printf ("Training interrupted, press Ctrl-C again to terminate immediately.\n");
  return;
};

