/* NFIDENT: a program for neuro-fuzzy function approximation

   Copyright (C) 1997-2000 

   Detlef Nauck (nauck@ieee.org, 
   http:\\fuzzy.cs.uni-magdeburg.de/~nauck)  
   hereby disclaims all copyright interests in the program 
   NFIDENT written by Detlef Nauck

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 1, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

MFuzzySystem *Create_Mamdani_Fuzzy_System (int nin, int nout, LParam *LP);
double Mamdani_Propagate_Pattern (MFuzzySystem *M, PSet *P, int which);
PMRule Allocate_New_Mamdani_Rule (int nin, int nout);
void Compute_Mamdani_Rulebase_Statistics(MFuzzySystem *M, PSet *P, int which);
void Reset_Mamdani_Statistics (MFuzzySystem *M);
void Compute_Mamdani_Rule_Statistics (MFuzzySystem *M, int r, PSet *P, int which);
int Create_Mamdani_Rulebase (MFuzzySystem *M, PSet *P);
void Compute_Mamdani_Rule_Fulfillments (MFuzzySystem *M);
int Mamdani_Test_Pattern (MFuzzySystem *M, PSet *P, const char *filename);
void Copy_Mamdani (MFuzzySystem *M, MFuzzySystem **Copy, LParam *LP);
int Evaluate_Mamdani_Rulebase (MFuzzySystem *M, PSet *P, LParam *LP);
